﻿Imports System
Imports System.Collections.Generic
Imports System.Web
Imports System.Web.Helpers

Namespace MsdnMvcWebGrid.Infrastructure
    ''' <summary>
    ''' Wrapper for System.Web.Helpers.WebGrid that preserves the item type from the data source
    ''' </summary>
    ''' <typeparam name="T"></typeparam>
    Public Class WebGrid(Of T)
        Inherits WebGrid
        ''' <param name="source">Data source</param>
        ''' <param name="columnNames">Data source column names. Auto-populated by default.</param>
        ''' <param name="defaultSort">Default sort column.</param>
        ''' <param name="rowsPerPage">Number of rows per page.</param>
        ''' <param name="canPage">true to enable paging</param>
        ''' <param name="canSort">true to enable sorting</param>
        ''' <param name="ajaxUpdateContainerId">ID for the grid's container element. This enables AJAX support.</param>
        ''' <param name="ajaxUpdateCallback">Callback function for the AJAX functionality once the update is complete</param>
        ''' <param name="fieldNamePrefix">Prefix for query string fields to support multiple grids.</param>
        ''' <param name="pageFieldName">Query string field name for page number.</param>
        ''' <param name="selectionFieldName">Query string field name for selected row number.</param>
        ''' <param name="sortFieldName">Query string field name for sort column.</param>
        ''' <param name="sortDirectionFieldName">Query string field name for sort direction.</param>
        Public Sub New(Optional ByVal source As IEnumerable(Of T) = Nothing, Optional ByVal columnNames As IEnumerable(Of String) = Nothing, Optional ByVal defaultSort As String = Nothing, Optional ByVal rowsPerPage As Integer = 10, Optional ByVal canPage As Boolean = True, Optional ByVal canSort As Boolean = True, Optional ByVal ajaxUpdateContainerId As String = Nothing, Optional ByVal ajaxUpdateCallback As String = Nothing, Optional ByVal fieldNamePrefix As String = Nothing, Optional ByVal pageFieldName As String = Nothing, Optional ByVal selectionFieldName As String = Nothing, Optional ByVal sortFieldName As String = Nothing, Optional ByVal sortDirectionFieldName As String = Nothing)
            MyBase.New(source.SafeCast(Of Object)(), columnNames, defaultSort, rowsPerPage, canPage, canSort, ajaxUpdateContainerId, ajaxUpdateCallback, fieldNamePrefix, pageFieldName, selectionFieldName, sortFieldName, sortDirectionFieldName)
        End Sub
        Public Function _Column(Optional ByVal columnName As String = Nothing, Optional ByVal header As String = Nothing, Optional ByVal format As Func(Of T, Object) = Nothing, Optional ByVal style As String = Nothing, Optional ByVal canSort As Boolean = True) As WebGridColumn
            Dim wrappedFormat As Func(Of Object, Object) = Nothing
            If format IsNot Nothing Then
                wrappedFormat = Function(o) format(CType(o.Value, T))
            End If
            Dim _scolumn As WebGridColumn = MyBase.Column(columnName, header, wrappedFormat, style, canSort)
            Return _scolumn
        End Function
        Public Function _Bind(ByVal source As IEnumerable(Of T), Optional ByVal columnNames As IEnumerable(Of String) = Nothing, Optional ByVal autoSortAndPage As Boolean = True, Optional ByVal rowCount As Integer = -1) As WebGrid(Of T)
            MyBase.Bind(source.SafeCast(Of Object)(), columnNames, autoSortAndPage, rowCount)
            Return Me
        End Function
    End Class
End Namespace