﻿@modeltype MsdnMvcWebGrid.Models.Product.PagedProductsModel
@imports MsdnMvcWebGrid.Infrastructure;
@imports MsdnMvcWebGrid.Domain;

<div id="grid" class="ajaxGrid">

@code
    'var grid = Html.ServerPagedGrid(Model.Products, Model.TotalRows, rowsPerPage: Model.PageSize, defaultSort: "Name");
    Dim grid = New WebGrid(Of Product)(Nothing, rowsPerPage:=Model.PageSize, defaultSort:="Name")
    grid.Bind(Model.Products, rowCount:=Model.TotalRows, autoSortAndPage:=False)

End code
@grid.GetHtml(columns:= grid.Columns(grid.Column("Name", format:= Function(item) _
                                                                      Html.ActionLink(item.Name, "Details", "Product", _
                                                                                      New With {Key .id = item.ProductId}, Nothing)), _
                                                                              grid.Column("ListPrice", header:= "List Price", _
                                                                                          format:=Function(item) item.ListPrice.ToString("0.00"))))
	<br />
</div>

<p>
	Model.Products.Count() = @Model.Products.Count()
</p>
<p>
	Model.TotalRows = @Model.TotalRows
</p>