﻿@modeltype MsdnMvcWebGrid.Models.Product.PagedProductsModel
@imports MsdnMvcWebGrid.Infrastructure;
@imports MsdnMvcWebGrid.Domain;
@code
    ViewBag.Title = "Server Paging"
End code

<h2>Server Paging</h2>


<div id="grid">

@code
    Dim grid = New WebGrid(Of Product)(Nothing, rowsPerPage:=Model.PageSize, defaultSort:="Name")
    grid.Bind(Model.Products, rowCount:=Model.TotalRows, autoSortAndPage:=False)
    ' NOTE: I've created another html helper to allow a server-paged grid to be rendered in one call (complete with compiler type inference) as shown below
    'var grid = Html.ServerPagedGrid(Model.Products, Model.TotalRows, rowsPerPage: Model.PageSize);
End code
@grid.GetHtml(columns:= grid.Columns(grid.Column("Name", format:= Function(item) _
                                                                      Html.ActionLink(item.Name, "Details", "Product", _
                                                                                      New With {Key .id = item.ProductId}, Nothing)), _
                                                                              grid.Column("ListPrice", header:= "List Price", _
                                                                                          format:=Function(item) item.ListPrice.ToString("0.00"))))
</div>

<p>
	Model.Products.Count() = @Model.Products.Count()
</p>
<p>
	Model.TotalRows = @Model.TotalRows
</p>